From: Xiong Zhou <xzhou@redhat.com>
To: fstests@vger.kernel.org
Cc: Xiong Zhou <xzhou@redhat.com>, Miklos Szeredi <mszeredi@redhat.com>
Subject: [PATCH 7/8] overlay: test flock after copied up
Date: Thu, 16 Feb 2017 17:13:54 +0800 [thread overview]
Message-ID: <1487236435-6222-7-git-send-email-xzhou@redhat.com> (raw)
In-Reply-To: <1487236435-6222-1-git-send-email-xzhou@redhat.com>
Locks of file in lower dir should working after it's
been copied up.
CC: Miklos Szeredi <mszeredi@redhat.com>
Signed-off-by: Xiong Zhou <xzhou@redhat.com>
---
tests/overlay/028 | 80 +++++++++++++++++++++++++++++++++++++++++++++++++++
tests/overlay/028.out | 2 ++
tests/overlay/group | 1 +
3 files changed, 83 insertions(+)
create mode 100755 tests/overlay/028
create mode 100644 tests/overlay/028.out
diff --git a/tests/overlay/028 b/tests/overlay/028
new file mode 100755
index 0000000..2e0995e
--- /dev/null
+++ b/tests/overlay/028
@@ -0,0 +1,80 @@
+#! /bin/bash
+# FS QA Test 028
+#
+# When file in lower dir is locked and it's been copied up,
+# make sure the lock is working in overlayfs.
+#
+# Kernel commit below fixed it.
+# c568d68341be locks: fix file locking on overlayfs
+#
+# This reproducer was originally written by
+# Miklos Szeredi <mszeredi@redhat.com>
+#
+#-----------------------------------------------------------------------
+# Copyright (c) 2017 Red Hat Inc. All Rights Reserved.
+#
+# This program is free software; you can redistribute it and/or
+# modify it under the terms of the GNU General Public License as
+# published by the Free Software Foundation.
+#
+# This program is distributed in the hope that it would be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write the Free Software Foundation,
+# Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
+#-----------------------------------------------------------------------
+#
+
+seq=`basename $0`
+seqres=$RESULT_DIR/$seq
+echo "QA output created by $seq"
+
+here=`pwd`
+tmp=/tmp/$$
+status=1 # failure is the default!
+trap "_cleanup; exit \$status" 0 1 2 3 15
+
+_cleanup()
+{
+ cd /
+ rm -f $tmp.*
+}
+
+# get standard environment, filters and checks
+. ./common/rc
+. ./common/filter
+
+# remove previous $seqres.full before test
+rm -f $seqres.full
+
+# real QA test starts here
+
+# Modify as appropriate.
+_supported_fs overlay
+_supported_os Linux
+_require_scratch
+
+# Remove all files from previous tests
+_scratch_mkfs
+
+lowerdir=$SCRATCH_DEV/$OVERLAY_LOWER_DIR
+mkdir -p $lowerdir
+touch $lowerdir/foo
+
+# Mounting overlay
+_scratch_mount
+
+# Testing copyup and flock
+flock $SCRATCH_MNT/foo sleep 5 &
+# flock in subshell should fail with no output
+(sleep 1; echo bar > $SCRATCH_MNT/foo; \
+ flock -n $SCRATCH_MNT/foo echo LOCKED)
+
+wait
+echo "Silence is golden"
+# success, all done
+status=0
+exit
diff --git a/tests/overlay/028.out b/tests/overlay/028.out
new file mode 100644
index 0000000..2615f73
--- /dev/null
+++ b/tests/overlay/028.out
@@ -0,0 +1,2 @@
+QA output created by 028
+Silence is golden
diff --git a/tests/overlay/group b/tests/overlay/group
index 4db6751..cf058fc 100644
--- a/tests/overlay/group
+++ b/tests/overlay/group
@@ -30,3 +30,4 @@
025 auto quick attr
026 auto attr quick
027 auto quick perms
+028 auto copyup quick
--
1.8.3.1
next prev parent reply other threads:[~2017-02-16 9:14 UTC|newest]
Thread overview: 18+ messages / expand[flat|nested] mbox.gz Atom feed top
2017-02-16 9:13 [PATCH 1/8] overlay: disallow overlayfs as upperdir Xiong Zhou
2017-02-16 9:13 ` [PATCH 2/8] overlay: work dir in overlay inherits no ACLs Xiong Zhou
2017-02-16 9:13 ` [PATCH 3/8] overlay: test workdir cleanup in mounting Xiong Zhou
2017-02-16 11:48 ` Amir Goldstein
2017-02-16 9:13 ` [PATCH 4/8] overlay: permission check with cached acls in tmpfs Xiong Zhou
2017-02-16 11:54 ` Amir Goldstein
2017-02-16 9:13 ` [PATCH 5/8] overlay: filter out xattr starts with "trusted.overlay." Xiong Zhou
2017-02-16 12:41 ` Amir Goldstein
2017-02-17 4:27 ` Xiong Zhou
2017-02-17 7:44 ` Amir Goldstein
2017-02-16 9:13 ` [PATCH 6/8] overlay: can not change underlying immutable file Xiong Zhou
2017-02-16 11:03 ` Eryu Guan
2017-02-16 9:13 ` Xiong Zhou [this message]
2017-02-16 12:06 ` [PATCH 7/8] overlay: test flock after copied up Amir Goldstein
2017-02-16 9:13 ` [PATCH 8/8] overlay: accessing stacked overlayfs files Xiong Zhou
2017-02-16 12:21 ` Amir Goldstein
2017-02-17 4:24 ` Xiong Zhou
2017-02-16 11:55 ` [PATCH 1/8] overlay: disallow overlayfs as upperdir Amir Goldstein
Reply instructions:
You may reply publicly to this message via plain-text email
using any one of the following methods:
* Save the following mbox file, import it into your mail client,
and reply-to-all from there: mbox
Avoid top-posting and favor interleaved quoting:
https://en.wikipedia.org/wiki/Posting_style#Interleaved_style
* Reply using the --to, --cc, and --in-reply-to
switches of git-send-email(1):
git send-email \
--in-reply-to=1487236435-6222-7-git-send-email-xzhou@redhat.com \
--to=xzhou@redhat.com \
--cc=fstests@vger.kernel.org \
--cc=mszeredi@redhat.com \
/path/to/YOUR_REPLY
https://kernel.org/pub/software/scm/git/docs/git-send-email.html
* If your mail client supports setting the In-Reply-To header
via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line
before the message body.
This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox